.286
IDEAL
;
ASSUME          CS:FLICODE, DS:FLICODE, ES:FLICODE, SS:NOTHING
;
SEGMENT         FLICODE PARA PUBLIC
;
PUBLIC          LCUnComp
;
PROC            LCUnComp

SourceSeg       EQU     <[bp+12]>
SourceOfs       EQU     <[bp+10]>
DestSeg         EQU     <[bp+08]>
DestOfs         EQU     <[bp+06]>

P               =       8

                Push    bp
                Mov     bp, sp
                Push    ds es si di

                Lds     si, SourceOfs
                Les     di, DestOfs

                Lodsw
                Mov     dx, 320
                Mul     dx
                Add     di, ax
                Lodsw
                Mov     bp, ax
                Mov     dx, di
                Xor     ax, ax
                Mov     bx, ax
;
ALIGN 4
@@10:           Mov     di, dx
                Lodsb
                Mov     bl, al
                And     bx, bx
                Jz      @@40
;
@@20:           Lodsb
                Add     di, ax
                Lodsb
                And     al, al
                Js      @@30
@@25:           Mov     cx, ax
                Rep     Movsb
                Dec     bx
                Jz      @@40

                REPT    3
                Lodsb
                Add     di, ax
                Lodsb
                And     al, al
                Js      @@30
                Mov     cx, ax
                Rep     Movsb
                Dec     bx
                Jz      @@40
                ENDM
                Lodsb
                Add     di, ax
                Lodsb
                And     al, al
                Js      @@30
                Mov     cx, ax
                Rep     Movsb
                Dec     bx
                Jnz     @@20
                Jmp     @@40
;
ALIGN 4
@@30:           Neg     al
                Mov     cx, ax
                Lodsb
                Rep     Stosb
                Dec     bx
                Jz      @@40
                Lodsb
                Add     di, ax
                Lodsb
                And     al, al
                Jns     @@25
                Neg     al
                Mov     cx, ax
                Lodsb
                Rep     Stosb
                Dec     bx
                Jnz     @@20
;
ALIGN 4
@@40:           Add     dx, 320
                Dec     bp
                Jnz     @@10

                Pop     di si es ds bp
                Retf    P

ENDP            LCUnComp
;
PUBLIC          UnComp
;
PROC            UnComp

NumLines        EQU     <[bp+14]>
SourceSeg       EQU     <[bp+12]>
SourceOfs       EQU     <[bp+10]>
DestSeg         EQU     <[bp+08]>
DestOfs         EQU     <[bp+06]>

P               =       10

                Push    bp
                Mov     bp, sp
                Push    ds es si di

                Lds     si, SourceOfs
                Les     di, DestOfs
                Mov     bp, NumLines

                Mov     dx, di
                Xor     ax, ax
                Mov     bx, ax
;
ALIGN 4
@@10:           Mov     di, dx
                Lodsb
                Mov     bl, al
                And     bx, bx
                Jz      @@40
;
ALIGN 4
@@20:           Lodsb
                And     al, al
                Js      @@30
                Mov     cx, ax
                Lodsb
                Rep     Stosb
                Dec     bx
                Jnz     @@20
                Jmp     @@40
;
ALIGN 4
@@30:           Neg     al
                Mov     cx, ax
                Rep     Movsb
                Dec     bx
                Jnz     @@20
;
ALIGN 4
@@40:           Add     dx, 320
                Dec     bp
                Jnz     @@10

                Pop     di si es ds bp
                Retf    P

ENDP            UnComp
;
PUBLIC          PalUnComp
;
PROC            PalUnComp

SourceSeg       EQU     <[bp+08]>
SourceOfs       EQU     <[bp+06]>

P               =       4

                Push    bp
                Mov     bp, sp
                Push    ds es si di

                Lds     si, SourceOfs

                Lodsw
                Mov     bx, ax
                And     bx, bx
                Jz      @@Exit
                Xor     ax, ax
                Mov     di, ax
                Mov     dx, 03C9h
;
@@10:           Lodsb
                Add     di, ax
                Mov     ax, di

                Dec     dx
                Mov     ax, di
                Out     dx, al
                Inc     dx

                Lodsb
                Add     di, ax

                Mov     cx, ax
                Jcxz    @@50
;
ALIGN 4
@@20:           Lodsb
                Out     dx, al

                Lodsb
                Out     dx, al

                Mov     dl, 0DAh
@@30:           In      al, dx
                Shr     al, 1
                Jnc     @@30

                Mov     dl, 0C9h
                Lodsb
                Out     dx, al

                Loop    @@20
;
                Dec     bx
                Jnz     @@10
;
@@Exit:         Pop     di si es ds bp
                Retf    P
;
@@50:           Mov     cx, 256
                Jmp     @@20

ENDP            PalUnComp
;
PUBLIC          GETINT
;
PROC            GETINT

PSegment        EQU     <[bp+08]>
POffset         EQU     <[bp+06]>

P               =       4

                Push    bp
                Mov     bp, sp
                Push    es

                Les     bx, POffset
                Mov     ax, [es:bx]

                Pop     es bp
                Retf    P

ENDP            GETINT
;
PUBLIC          GETLONG
;
PROC            GETLONG

PSegment        EQU     <[bp+08]>
POffset         EQU     <[bp+06]>

P               =       4

                Push    bp
                Mov     bp, sp
                Push    es

                Les     bx, POffset
                Les     ax, [es:bx]
                Mov     dx, es

                Pop     es bp
                Retf    P

ENDP            GETLONG
;
PUBLIC          WAITWHILEIN
;
PROC            WAITWHILEIN

                Mov     dx, 03DAh
@@10:           In      al, dx
                Test    al, 8
                Jnz     @@10

                Retf

ENDP            WAITWHILEIN
;
PUBLIC          WAITWHILEOUT
;
PROC            WAITWHILEOUT

                Mov     dx, 03DAh
@@10:           In      al, dx
                Test    al, 8
                Jz      @@10

                Retf

ENDP            WAITWHILEOUT
;
CMODE	        EQU 043h
CDATA	        EQU 040h
;
PUBLIC          GOCLOCK
;
PROC            GOCLOCK

                Mov al, 00110100b       ;put it into linear count instead of divide by 2
                Out CMODE, al
                Xor al, al
                Out CDATA, al
                Out CDATA, al

                Retf

ENDP            GOCLOCK
;
;this routine returns a clock with occassional spikes where time
;will look like its running backwards 1/18th of a second.  The resolution
;of the clock is 1/(18*256) = 1/4608 second.  66 ticks of this clock
;are supposed to be equal to a monitor 1/70 second tick.
;
PUBLIC          GETCLOCK
;
PROC            GETCLOCK

                Xor     ah, ah
                Int     01Ah
                Mov     ah, dl
                Mov     dl, dh
                Mov     dh, cl

                Xor     al, al
                Out     CMODE, al       ;latch count
                Inc     ax
                Out     CMODE, al       ;set up to read count
                In      al, CDATA       ;read in lo byte (and discard)
                In      al, CDATA       ;hi byte into al
                Neg     al              ;make it so counting up instead of down

                Retf

ENDP            GETCLOCK
;
ENDS            FLICODE
;
END
