'
' FLIASM.BI
'
' /* FLI Specific Stuff FLIASM.ASM */
DECLARE SUB LCUnComp (BYVAL SourceSeg%, BYVAL SourceOfs%, BYVAL DestSeg%, BYVAL DestOfs%)
DECLARE SUB UnComp (BYVAL NumLines%, BYVAL SourceSeg%, BYVAL SourceOfs%, BYVAL DestSeg%, BYVAL DestOfs%)
DECLARE SUB PalUnComp (BYVAL SourceSeg%, BYVAL SourceOfs%)
DECLARE FUNCTION GETINT% (BYVAL PSegment%, BYVAL POffset%)
DECLARE FUNCTION GETLONG& (BYVAL PSegment%, BYVAL POffset%)
DECLARE SUB WAITWHILEIN ()
DECLARE SUB WAITWHILEOUT ()
DECLARE SUB GOCLOCK ()
DECLARE FUNCTION GETCLOCK& ()
'
' /* Critical Error Handling IO.ASM */
DECLARE SUB GRAB24 CDECL ALIAS "_GrabInt24" ()
DECLARE SUB RELEASE24 CDECL ALIAS "_ReleaseInt24" ()
'
' /* Disk I/O FILEIO.ASM */
DECLARE FUNCTION FILEOPEN% CDECL ALIAS "_FileOpen" (BYVAL filename%, BYVAL Attr%, handle%)
DECLARE FUNCTION FILECREATE% CDECL ALIAS "_FileCreate" (BYVAL filename%, BYVAL Attr%, handle%)
DECLARE FUNCTION FILEMAKE% CDECL ALIAS "_FileMake" (BYVAL filename%, BYVAL Attr%, BYVAL handle%)
DECLARE SUB FILECLOSE CDECL ALIAS "_FileClose" (BYVAL handle%)
DECLARE FUNCTION FILEREAD% CDECL ALIAS "_FileRead" (BYVAL handle%, BYVAL ReadOfs%, BYVAL ReadSeg%, BYVAL ReadLen%)
DECLARE FUNCTION FILEWRITE% CDECL ALIAS "_FileWrite" (BYVAL handle%, BYVAL WriteOfs%, BYVAL WriteSeg%, BYVAL WriteLen%)
DECLARE FUNCTION FILESEEK% CDECL ALIAS "_FileSeek" (BYVAL handle%, BYVAL Method%, BYVAL SeekOfs&)
DECLARE FUNCTION FILEPOINTER% CDECL ALIAS "_FilePointer" (BYVAL handle%, SeekOfs&)
DECLARE FUNCTION FILESIZE% CDECL ALIAS "_FileSize" (BYVAL handle%, FileLen&)
DECLARE FUNCTION FILERENAME% CDECL ALIAS "_FileRename" (BYVAL OldName%, BYVAL NewName%)
DECLARE FUNCTION FILEDELETE% CDECL ALIAS "_FileDelete" (BYVAL filename%)
DECLARE FUNCTION FILESETDATETIME% CDECL ALIAS "_FileSetDateTime" (BYVAL handle%, BYVAL NewDate%, BYVAL NewTime%)
DECLARE FUNCTION FILEGETDATETIME% CDECL ALIAS "_FileGetDateTime" (BYVAL handle%, FileDate%, FileTime%)
DECLARE FUNCTION FILESETATTR% CDECL ALIAS "_FileSetAttr" (BYVAL filename%, BYVAL NewAttr%)
DECLARE FUNCTION FILEGETATTR% CDECL ALIAS "_FileGetAttr" (BYVAL filename%)
DECLARE FUNCTION DELETEDIR% CDECL ALIAS "_DeleteDir" (BYVAL pathname%)
'
' /* Misc. Stuff MISC.ASM */
DECLARE FUNCTION LONG2INT% (BYVAL Integer32&)
DECLARE FUNCTION INT2LONG& (BYVAL Integer16%)
DECLARE SUB MemMove (BYVAL SourceSeg%, BYVAL SourceOfs%, BYVAL DestSeg%, BYVAL DestOfs%, BYVAL NumBytes%)
DECLARE SUB MemClear (BYVAL DestSeg%, BYVAL DestOfs%, BYVAL DestLen%, BYVAL DestByte%)
DECLARE SUB DefaultPal (BYVAL DestSeg%, BYVAL DestOfs%)
'
' /* XMS Assembly Code XMS.ASM */
DECLARE FUNCTION XMSInit% CDECL ALIAS "_XMSInit" ()
DECLARE FUNCTION XMSMaxFree% CDECL ALIAS "_XMSMaxFree" (MaxFree%)
DECLARE FUNCTION XMSAllocate% CDECL ALIAS "_XMSAllocate" (BYVAL Kilobytes%, Handle%)
DECLARE FUNCTION XMSFree% CDECL ALIAS "_XMSFree" (BYVAL Handle%)
DECLARE FUNCTION CopyToXMS% CDECL ALIAS "_CopyToXMS" (BYVAL DestHandle%, BYVAL DestOfs&, BYVAL SourceSeg%, BYVAL SourceOfs%, BYVAL NumBytes&)
DECLARE FUNCTION CopyFromXMS% CDECL ALIAS "_CopyFromXMS" (BYVAL SourceHandle%, BYVAL SourceOfs&, BYVAL DestSeg%, BYVAL DestOfs%, BYVAL NumBytes&)
DECLARE SUB XMSFreeAll CDECL ALIAS "_XMSFreeAll" ()
'
' /* A Few Mouse Routines MOUSE.ASM */
DECLARE FUNCTION MouseDetect% ()
DECLARE FUNCTION MouseEscape% ()
DECLARE FUNCTION MouseEnter% ()
DECLARE SUB MouseVector (VectorX%, VectorY%)
'
' /* More Misc. Stuff RGMISC.ASM */
DECLARE SUB SCREENOFF
DECLARE SUB SCREENON
'
' /* VGA Fading Code FADE.ASM */
DECLARE SUB FADEPAL (BYVAL NumColors%, BYVAL Intensity%, BYVAL WorkSeg%, BYVAL SourceOfs%, BYVAL DestOfs%)
DECLARE SUB SETPAL (BYVAL NumColors%, BYVAL SourceSeg%, BYVAL SourceOfs%)
'

