.286
IDEAL
;
ASSUME          CS:MouseCode, DS:NOTHING, ES:NOTHING, SS:NOTHING
;
SEGMENT         MouseCode PARA PUBLIC
;
FoundMouse      dw      0
Initialized     dw      0
;
PUBLIC          MouseDetect
;
PROC            MouseDetect

                Cmp     [cs:Initialized], -1
                Jne     @@Ok
                Mov     ax, [cs:FoundMouse]
                Retf
@@Ok:
                Mov     [cs:Initialized], -1

                Mov     bx, 0FFFFh
                Mov     ax, 021h
                Int     033h
                Cmp     ax, 0FFFFh
                Jne     @@NoMouse
                Cmp     bx, 0FFFFh
                Je      @@NoMouse

@@Mouse:        Mov     ax, -1
                Mov     [cs:FoundMouse], ax
                Retf

@@NoMouse:      Xor     ax, ax
                Mov     [cs:FoundMouse], ax
                Retf

ENDP            MouseDetect
;
PUBLIC          MouseEscape
;
PROC            MouseEscape

                Cmp     [cs:FoundMouse], 0
                Je      @@NoEscape

                Mov     ax, 5
                Mov     bx, 1
                Int     033h
                And     bx, bx
                Jz      @@NoEscape
                Mov     ax, -1
                Retf
@@NoEscape:     Xor     ax, ax
                Retf

ENDP            MouseEscape
;
PUBLIC          MouseEnter
;
PROC            MouseEnter

                Cmp     [cs:FoundMouse], 0
                Je      @@NoEnter

                Mov     ax, 5
                Xor     bx, bx
                Int     033h
                And     bx, bx
                Jz      @@NoEnter
                Mov     ax, -1
                Retf
@@NoEnter:      Xor     ax, ax
                Retf

ENDP            MouseEnter
;
PUBLIC          MouseVector
;
PROC            MouseVector

VectorX         EQU     <[bp+08]>
VectorY         EQU     <[bp+06]>

P               =       4

                Push    bp
                Mov     bp, sp

                Xor     cx, cx
                Xor     dx, dx
                Cmp     [cs:FoundMouse], 0
                Je      @@Exit

                Mov     ax, 11
                Int     033h

@@Exit:         Mov     bx, VectorX
                Mov     [bx], cx
                Mov     bx, VectorY
                Mov     [bx], dx

                Pop     bp
                Retf    P

ENDP            MouseVector
;
ENDS            MouseCode
;
END
