.286
IDEAL
;
EXTRN           StringAddress:FAR
;
ASSUME          CS:RGMISC, DS:NOTHING, ES:NOTHING: SS:NOTHING
;
SEGMENT         RGMISC PARA PUBLIC
;
ICOData:

db 00h,00h,01h,00h,01h,00h,020h,020h,010h,00h,00h,00h,00h,00h
db 0E8h,02h,00h,00h,016h,00h,00h,00h,028h,00h,00h,00h,020h,00h
db 00h,00h,040h,00h,00h,00h,01h,00h,04h,00h,00h,00h,00h,00h,080h
db 02h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,080h,00h,00h,080h
db 00h,00h,00h,080h,080h,00h,080h,00h,00h,00h,080h,00h,080h,00h
db 080h,080h,00h,00h,080h,080h,080h,00h,0C0h,0C0h,0C0h,00h,00h
db 00h,0FFh,00h,00h,0FFh,00h,00h,00h,0FFh,0FFh,00h,0FFh,00h,00h
db 00h,0FFh,00h,0FFh,00h,0FFh,0FFh,00h,00h,0FFh,0FFh,0FFh,00h

;
PUBLIC          GrabVal
;
ALIGN 4
PROC            GrabVal

PString         EQU     <[bx+08]>
PStrOfs         EQU     <[bx+06]>
PStrLen         EQU     <[bx+04]>

P               =       6

                Mov     bx, sp
                Push    PString
                Call    StringAddress
                Mov     bx, sp
                Mov     es, dx
                Mov     si, ax
;
                Mov     dx, PStrLen
                And     dx, dx
                Jz      @@Error
;
                Mov     di, PStrOfs
                Dec     di
                Jl      @@Error
                Sub     cx, di
                Jl      @@Error
                Add     si, di
;
                Cmp     dx, cx
                Ja      @@Fix
@@Fixed:
;

;es:si = string offset
;dx = num characters to parse

;45 and 48-57
                Xor     ax, ax
                Mov     bx, ax
                Mov     di, ax
                Mov     cx, ax
ALIGN 4
@@SumLoop:      Lods    [BYTE es:si]
                Sub     al, 48
                Jb      @@CheckLow
                Cmp     al, (57 - 48)
                Ja      @@Exit

                IMul    bx, 10
                Add     bx, ax
                Inc     cx

@@DoNextChar:   Dec     dx
                Jnz     @@SumLoop
;
@@Exit:         Mov     ax, bx
                Xor     ax, di
                Sub     ax, di
                Retf    P
;
ALIGN 4
@@Error:        Xor     ax, ax
                Retf    P
;
ALIGN 4
@@CheckLow:     Cmp     al, -16
                Je      @@Space
                Cmp     al, -3
                Jne     @@Exit
                And     cx, cx
                Jnz     @@Exit
                Xor     di, 0FFFFh
                Jnz     @@DoNextChar
                Jmp     @@Error
;
@@Space:        And     cx, cx
                Jz      @@DoNextChar
                Jmp     @@Exit
;
ALIGN 4
@@Fix:          Mov     dx, cx
                Jmp     @@Fixed

ENDP            GrabVal
;
PUBLIC          ScreenOff
;
PROC            ScreenOff

                Mov     dx, 03DAh

@@10:           In      al, dx
                Test    al, 8
                Jz      @@10

                Mov     dl, 0C4h
                Mov     al, 1
                Out     dx, al
                Inc     dx
                In      al, dx
                Or      al, 32
                Out     dx, al

                Mov     dl, 0DAh
@@20:           In      al, dx
                Test    al, 8
                Jnz     @@20

                Retf

ENDP            ScreenOff
;
PUBLIC          ScreenOn
;
PROC            ScreenOn

                Mov     dx, 03DAh

@@10:           In      al, dx
                Test    al, 8
                Jz      @@10

                Mov     dl, 0C4h
                Mov     al, 1
                Out     dx, al
                Inc     dx
                In      al, dx
                And     al, NOT 32
                Out     dx, al

                Mov     dl, 0DAh
@@20:           In      al, dx
                Test    al, 8
                Jnz     @@20

                Retf

ENDP            ScreenOn
;
PUBLIC          CopyICOHeader
;
PROC            CopyICOHeader

DestSeg         EQU     <[bp+08]>
DestOfs         EQU     <[bp+06]>

P               =       4

                Push    bp
                Mov     bp, sp
                Push    ds es si di

                Push    cs
                Pop     ds
                Mov     si, offset ICOData

                Les     di, DestOfs
                Mov     cx, 126
                Rep     Movsb

                Pop     di si es ds bp
                Retf    P

ENDP            CopyICOHeader
;
ENDS            RGMISC
;
END
